VERSION 5.00
Begin VB.Form frmMars 
   Caption         =   "Interleave Customers and Orders"
   ClientHeight    =   8235
   ClientLeft      =   60
   ClientTop       =   450
   ClientWidth     =   8340
   LinkTopic       =   "Form1"
   ScaleHeight     =   8235
   ScaleWidth      =   8340
   StartUpPosition =   3  'Windows Default
   Begin VB.ComboBox cboServer 
      BeginProperty Font 
         Name            =   "MS Sans Serif"
         Size            =   18
         Charset         =   0
         Weight          =   400
         Underline       =   0   'False
         Italic          =   0   'False
         Strikethrough   =   0   'False
      EndProperty
      Height          =   555
      ItemData        =   "frmMars.frx":0000
      Left            =   2880
      List            =   "frmMars.frx":0007
      TabIndex        =   3
      Text            =   "cboServer"
      Top             =   720
      Width           =   5295
   End
   Begin VB.ListBox lstResults 
      BeginProperty Font 
         Name            =   "MS Sans Serif"
         Size            =   18
         Charset         =   0
         Weight          =   400
         Underline       =   0   'False
         Italic          =   0   'False
         Strikethrough   =   0   'False
      EndProperty
      Height          =   5280
      Left            =   120
      TabIndex        =   7
      Top             =   2760
      Width           =   8055
   End
   Begin VB.CommandButton cmdRunTest 
      Caption         =   "Run Test"
      Default         =   -1  'True
      BeginProperty Font 
         Name            =   "MS Sans Serif"
         Size            =   18
         Charset         =   0
         Weight          =   400
         Underline       =   0   'False
         Italic          =   0   'False
         Strikethrough   =   0   'False
      EndProperty
      Height          =   735
      Left            =   5880
      TabIndex        =   6
      Top             =   1920
      Width           =   2295
   End
   Begin VB.TextBox txtWhereClause 
      BeginProperty Font 
         Name            =   "MS Sans Serif"
         Size            =   18
         Charset         =   0
         Weight          =   400
         Underline       =   0   'False
         Italic          =   0   'False
         Strikethrough   =   0   'False
      EndProperty
      Height          =   525
      Left            =   2880
      TabIndex        =   5
      Text            =   "CompanyName LIKE 'C%'"
      Top             =   1320
      Width           =   5295
   End
   Begin VB.TextBox txtDriver 
      BeginProperty Font 
         Name            =   "MS Sans Serif"
         Size            =   18
         Charset         =   0
         Weight          =   400
         Underline       =   0   'False
         Italic          =   0   'False
         Strikethrough   =   0   'False
      EndProperty
      Height          =   525
      Left            =   2880
      TabIndex        =   1
      Text            =   "SQLNCLI"
      Top             =   120
      Width           =   5295
   End
   Begin VB.Label lblWhereClause 
      Caption         =   "WHERE Clause:"
      BeginProperty Font 
         Name            =   "MS Sans Serif"
         Size            =   18
         Charset         =   0
         Weight          =   400
         Underline       =   0   'False
         Italic          =   0   'False
         Strikethrough   =   0   'False
      EndProperty
      Height          =   495
      Left            =   120
      TabIndex        =   4
      Top             =   1320
      Width           =   2895
   End
   Begin VB.Label lblServer 
      Caption         =   "Server:"
      BeginProperty Font 
         Name            =   "MS Sans Serif"
         Size            =   18
         Charset         =   0
         Weight          =   400
         Underline       =   0   'False
         Italic          =   0   'False
         Strikethrough   =   0   'False
      EndProperty
      Height          =   495
      Left            =   120
      TabIndex        =   2
      Top             =   720
      Width           =   2655
   End
   Begin VB.Label lblDriver 
      Caption         =   "Provider:"
      BeginProperty Font 
         Name            =   "MS Sans Serif"
         Size            =   18
         Charset         =   0
         Weight          =   400
         Underline       =   0   'False
         Italic          =   0   'False
         Strikethrough   =   0   'False
      EndProperty
      Height          =   495
      Left            =   120
      TabIndex        =   0
      Top             =   120
      Width           =   2415
   End
End
Attribute VB_Name = "frmMars"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = False
Attribute VB_PredeclaredId = True
Attribute VB_Exposed = False
Private WithEvents cn As ADODB.Connection
Attribute cn.VB_VarHelpID = -1
Private WithEvents rsNotify As ADODB.Recordset
Attribute rsNotify.VB_VarHelpID = -1


Private Sub cmdRunTest_Click()
    Dim objCustomers As CustomerCollection
    Dim objCustomer As CustomerClass
    Dim objOrder As OrderClass
    
    'On Error Resume Next
    If cn Is Nothing Then
        Set cn = New ADODB.Connection
        cn.CursorLocation = adUseServer
        cn.CommandTimeout = 0
        cn.Open ("Provider=" & txtDriver.Text & _
                     ";Data Source=" & cboServer.Text & _
                     ";Database=Northwind;Trusted_Connection=No;User Id=chris;Password=demo;MARS Connection=true")
    End If
    
    Set objCustomers = GetCustomers(cn, txtWhereClause.Text)
    If Err.Number <> 0 Then
        MsgBox Err.Description
    Else
        lstResults.Clear
        For Each objCustomer In objCustomers
            lstResults.AddItem objCustomer.CompanyName + "  -  " + objCustomer.ContactName
        Next objCustomer
    End If
End Sub

Private Sub cn_ExecuteComplete(ByVal RecordsAffected As Long, _
                                ByVal pError As ADODB.Error, _
                                adStatus As ADODB.EventStatusEnum, _
                                ByVal pCommand As ADODB.Command, _
                                ByVal pRecordset As ADODB.Recordset, _
                                ByVal pConnection As ADODB.Connection)
            
    If pRecordset Is rsNotify Then
        If adStatus = adStatusErrorsOccurred Then
            MsgBox pError.Description
        Else
            lstResults.Clear
            Set objCustomers = GetCustomers(cn, txtWhereClause.Text)
            For Each objCustomer In objCustomers
                lstResults.AddItem objCustomer.CompanyName + "  -  " + objCustomer.ContactName
            Next objCustomer
        End If
    End If
End Sub


Public Function GetCustomers(ByRef cn As ADODB.Connection, _
                             WhereClause As String) As CustomerCollection
    Dim objCustomers As CustomerCollection
    Dim objCustomer As CustomerClass
    Set objCustomers = New CustomerCollection
    
    Dim qryCustomers As ADODB.Command
    Dim rsCustomers As ADODB.Recordset
    
    Set qryCustomers = New ADODB.Command
    Set qryCustomers.ActiveConnection = cn
    
    qryCustomers.Properties("Query Notification Options") = "Service=myService"
    qryCustomers.Properties("Query Notification MsgText") = "DemoNotification"
    qryCustomers.Properties("Query Notification Timeout") = 1000000
    
    qryCustomers.CommandText = "SELECT CustomerID, CompanyName, ContactName, Phone" & _
                       " FROM dbo.Customers" & _
                       " WHERE " & WhereClause & _
                       " ORDER BY CompanyName"
                           
    Set rsCustomers = qryCustomers.Execute
    Do While Not rsCustomers.EOF
        Set objCustomer = objCustomers.Add(rsCustomers!CustomerID, _
                                           rsCustomers!CompanyName, _
                                           rsCustomers!ContactName, _
                                           rsCustomers!Phone, _
                                           New OrderCollection)
        rsCustomers.MoveNext
    Loop
    rsCustomers.Close
    
    Set GetCustomers = objCustomers
        
    If rsNotify Is Nothing Then
        Set rsNotify = New ADODB.Recordset
    End If
    If rsNotify.State = adStateOpen Then
        rsNotify.Close
    End If
    rsNotify.Open "waitfor (receive * from dbo.myQueue)", _
                        cn, adOpenForwardOnly, adLockReadOnly, adAsyncExecute
    
End Function

Private Sub Form_Load()
    cboServer.Text = cboServer.List(0)
End Sub
